<?php
/**
 *
 * Copyright(c) 2006-2020 ThreatSTOP, Inc. All Rights Reserved
 *
 * NOTICE: All information contained herein is, and remains the property
 * of ThreatSTOP, Inc. and its suppliers, if any. The intellectual and
 * technical concepts contained herein are proprietary to ThreatSTOP, Inc.
 * and its suppliers and certain aspects thereof are protected by United
 * States Patent No. 8,533,822 and United States Patent No. 8,869,237,
 * and are protected by trade secret or copyright law.
 *
 * US Government Entities: The ThreatSTOP service, software and
 * documentation, as applicable, are "commercial computer software" and
 * "commercial computer software documentation" developed exclusively at
 * private expense by Threatstop, Inc. ("Threatstop"). Pursuant to FAR
 * 12.212 or DFARS 227 7202 and their successors, as applicable, use,
 * reproduction and disclosure of the software and documentation is
 * governed by the terms of Threatstop's commercial agreement.
 */

//Load pfsense modules
require "guiconfig.inc";
require_once "functions.inc";
require_once "filter.inc";
require "shaper.inc";
require_once "config.gui.inc";

// Make ThreatSTOP rules
$rule = array(
	'type' => 'pass',
	'interface' => 'lan',
	'statetype' => 'keep state',
	'source' => array(
		'any' => true,
	),
	'destination' => array(
		'address' => 'ThreatSTOP_allow',
	),
	'log' => true,
	'descr' => 'ThreatSTOP_incoming_lan',
);

$rule2 = array(
	'type' => 'block',
	'interface' => 'lan',
	'statetype' => 'keep state',
	'source' => array(
		'any' => true,
	),
	'destination' => array(
		'address' => 'ThreatSTOP_block',
	),
	'log' => true,
	'descr' => 'ThreatSTOP_incoming_lan',
);
//If gateway mode

$rule4 = array(
	'type' => 'pass',
	'interface' => 'wan',
	'statetype' => 'keep state',
	'source' => array(
		'address' => 'ThreatSTOP_allow',
	),
	'destination' => array(
		'any' => true,
	),
	'log' => true,
	'descr' => 'ThreatSTOP_incoming_wan',
);
$rule5 = array(
	'type' => 'block',
	'interface' => 'wan',
	'statetype' => 'keep state',
	'source' => array(
		'address' => 'ThreatSTOP_block',
	),
	'destination' => array(
		'any' => true,
	),
	'log' => true,
	'descr' => 'ThreatSTOP_incoming_wan',
);
//Make ThreatSTOP aliase. This files consit block and allow ThreatSTOP address
$alias = array(
	'name' => 'ThreatSTOP_allow',
	'url' => 'http://localhost/tsread.php?policy_file=ThreatSTOP_allow.txt',
	'updatefreq' => '128',
	'address' => '',
	'descr' => '',
	'type' => 'urltable',
	'detail' => '',
);
$alias2 = array(
	'name' => 'ThreatSTOP_block',
	'url' => 'http://localhost/tsread.php?policy_file=ThreatSTOP_block.txt',
	'updatefreq' => '128',
	'address' => '',
	'descr' => '',
	'type' => 'urltable',
	'detail' => '',
);

global $config;
array_unshift($config['filter']['rule'], $rule, $rule2, $rule4, $rule5);

if (!$config['aliases'] or !is_array($config['aliases']['alias'])) {
    $config['aliases'] = Array('alias' => Array());
}
// if (array_key_exists('aliases', $config['aliases']])) {
// 	echo "removing aliases => aliases";
// 	unset($config['aliases']]['aliases']]);
// }
array_unshift($config['aliases']['alias'], $alias, $alias2);
// $config['aliases']['alias'][] = $alias;
// $config['aliases']['alias'][] = $alias2;
foreach ($config['aliases']['alias'] as $key => $some_alias) {
	if (empty($some_alias)) {
		unset($config['aliases']['alias'][$key]);
	}
}

//store previous noantilockout state, and then turn it on
if (!$config['threatstop']) {
	$config['threatstop'] = array();
}
if (isset($config['system']['webgui']['noantilockout'])) {
	$config['threatstop']['noantilockout'] = true;
} else {
	$config['threatstop']['noantilockout'] = false;
}

// threatstop user / group stuff
// $TSGID = '1501';
$TSGID = trim(shell_exec('getent group threatstop | cut -d: -f3'));
// $TSGID = trim(shell_exec('id -g threatstop')); # fetches the default group ID of USER threatstop not group threatstop
// $TSUID = '1501';
$TSUID = trim(shell_exec('id -u threatstop'));
$needs_threatstop_sudo_row = true;
$needs_threatstop_user = true;
foreach ($config['system']['user'] as $rkey => $row) {
	if ($row['name'] == "threatstop") {
		$needs_threatstop_user = false;
	}
}
$needs_threatstop_group = true;
foreach ($config['system']['group'] as $rkey => $row) {
	if ($row['name'] == "threatstop") {
		$needs_threatstop_group = false;
	}
}

// define threatstop group sudo role
$ts_sudo = array(
    "username" => "user:threatstop",
    "runas" => "user:root",
    "cmdlist" => "ALL",
    "nopasswd" => "ON",
);

$ts_user = array(
    "scope" => 'user',
    "bcrypt-hash" => '',
    // "bcrypt-hash" => '$2y$10$3bG7fKHkz53aFeKW0cAk7uYIXm5Cu9HDZluU1VI2I5RxMAChPY.fy',
    "descr" => 'ThreatSTOP Service Acct',
    "name" => 'threatstop',
    "expires" =>'',
    "dashboardcolumns" => 2,
    "groupname" => "threatstop",
    "authorizedkeys" => '',
    "ipsecpsk" =>'',
    "webguicss" => 'pfSense.css',
    "uid" => $TSUID,
    // "disabled" => '',
);

$ts_group = array(
	"name" => 'threatstop',
    "description" => 'ThreatSTOP Administrators',
    "scope" => 'system',
    "gid" => $TSGID,
    "member" => array('0', $TSUID),
    "priv" => array('page-all')
);

// $fp = fopen('/tmp/threatstop_test.log', 'a+');
// fwrite($fp, "CONFIG: " . print_r($config, true));
if (isset($config['installedpackages']) && isset($config['installedpackages']['sudo'])) {
	if (is_array($config['installedpackages']['sudo']['config'])) {
		// loop through array ensure threatstop group exists
		foreach ($config['installedpackages']['sudo']['config'][0]['row'] as $rkey => $row) {
			// fwrite($fp, "ROW[$rkey]: " . print_r($row, true));
			if ($row['username'] == "user:threatstop") {
				// fwrite($fp, 'no threatstop group needed');
				$needs_threatstop_sudo_row = false;
			}
		}
	}
}


if ($needs_threatstop_user) {
	// fwrite($fp, 'Adding threatstop user');
	array_push($config['system']['user'], $ts_user);
}
if ($needs_threatstop_group) {
	// fwrite($fp, 'Adding threatstop group');
	array_push($config['system']['group'], $ts_group);
}
if ($needs_threatstop_sudo_row) {
	// fwrite($fp, 'Adding threatstop sudo');
	array_push($config['installedpackages']['sudo']['config'][0]['row'], $ts_sudo);
}
// fclose($fp);

$config['system']['webgui']['noantilockout'] = true;

write_config('Enable ThreatSTOP');
filter_configure();
sleep(2);
header("Location: /ts_state.php");
shell_exec('rm  /tmp/config.cache');
//add ThreatStop lists
//include 'tsgetblockip.php';

?>